searchData={"items":[{"type":"module","title":"AoC","doc":"","ref":"AoC.html"},{"type":"function","title":"AoC.run/4","doc":"","ref":"AoC.html#run/4"},{"type":"type","title":"AoC.file/0","doc":"","ref":"AoC.html#t:file/0"},{"type":"type","title":"AoC.input/0","doc":"","ref":"AoC.html#t:input/0"},{"type":"type","title":"AoC.input_path/0","doc":"","ref":"AoC.html#t:input_path/0"},{"type":"type","title":"AoC.part/0","doc":"","ref":"AoC.html#t:part/0"},{"type":"type","title":"AoC.problem/0","doc":"","ref":"AoC.html#t:problem/0"},{"type":"module","title":"AoC.API","doc":"","ref":"AoC.API.html"},{"type":"function","title":"AoC.API.fetch_input/2","doc":"","ref":"AoC.API.html#fetch_input/2"},{"type":"module","title":"AoC.CLI","doc":"","ref":"AoC.CLI.html"},{"type":"function","title":"AoC.CLI.color/2","doc":"Outputs `iodata` in the current shell, wrapped with formatting\ninformation, such as `[color, iodata, :default_color]`.\n\n`color` should be a `IO.ANSI.format/2` compatible atom.","ref":"AoC.CLI.html#color/2"},{"type":"function","title":"AoC.CLI.compile/0","doc":"","ref":"AoC.CLI.html#compile/0"},{"type":"function","title":"AoC.CLI.debug/1","doc":"Outputs `iodata` in the current shell, formatted with cyan color.","ref":"AoC.CLI.html#debug/1"},{"type":"function","title":"AoC.CLI.error/1","doc":"Outputs `iodata` to `stderr` in the current shell, formatted with bright\nred color.","ref":"AoC.CLI.html#error/1"},{"type":"function","title":"AoC.CLI.format_usage/2","doc":"Returns a standard \"usage\" documentation block describing the different\noptions of the given command.\n\n#","ref":"AoC.CLI.html#format_usage/2"},{"type":"function","title":"Options - AoC.CLI.format_usage/2","doc":"* `:format` - If `:moduledoc`, the formatted usage will be compatible for\n  embedding in a `@moduledoc` attribute. Any other value will generate a\n  simple terminal styled text. Defaults to `:cli`.","ref":"AoC.CLI.html#format_usage/2-options"},{"type":"function","title":"AoC.CLI.halt/1","doc":"Stops the execution of the Erlang runtime, with a given return code.\n\nIf not provided, the return code will be `0`.","ref":"AoC.CLI.html#halt/1"},{"type":"function","title":"AoC.CLI.halt_error/2","doc":"Combines `error/1` then `halt/1`. Halts the Erlang runtime with a `1`\nreturn code by default.","ref":"AoC.CLI.html#halt_error/2"},{"type":"function","title":"AoC.CLI.halt_success/1","doc":"Combines `success/1` then `halt/1`. Halts the Erlang runtime with a `0`\nreturn code.","ref":"AoC.CLI.html#halt_success/1"},{"type":"function","title":"AoC.CLI.init_env/0","doc":"","ref":"AoC.CLI.html#init_env/0"},{"type":"macro","title":"AoC.CLI.is_valid_day/1","doc":"","ref":"AoC.CLI.html#is_valid_day/1"},{"type":"macro","title":"AoC.CLI.is_valid_day/2","doc":"","ref":"AoC.CLI.html#is_valid_day/2"},{"type":"macro","title":"AoC.CLI.is_valid_part/1","doc":"","ref":"AoC.CLI.html#is_valid_part/1"},{"type":"macro","title":"AoC.CLI.is_valid_year/1","doc":"","ref":"AoC.CLI.html#is_valid_year/1"},{"type":"function","title":"AoC.CLI.parse/2","doc":"Accepts the command line arguments and the definition of a command\n(options, arguments, and metadata) and returns a parse result with values\nextracted from the command line arguments.\n\n#","ref":"AoC.CLI.html#parse/2"},{"type":"function","title":"Defining options - AoC.CLI.parse/2","doc":"Options definitions is a `Keyword` whose keys are the option name, and\nvalues are the options parameters. Note that keys with underscores like\n`some_thing` define options in kebab case like `--some-thing`.\n\nThe following parameters are available:\n\n- `:type` - Can be either `:boolean`, `:integer` or `:string`. The default\n  value is `:string`.\n- `:short` - Defines the shortcut for the option, for instance `-p`\n  instead of `--port`.\n- `:default` - Defines the default value if the corresponding option is\n  not defined in `argv`. Keys for without default values that are not\n  provided in `argv` will not be defined in the results.\n- `:doc` - Accepts a string that will be used when formatting the usage\n  block for the command.\n\nNote that the `:help` option is always defined and cannot be overridden.\n\n#","ref":"AoC.CLI.html#parse/2-defining-options"},{"type":"function","title":"Options examples - AoC.CLI.parse/2","doc":"iex> {:ok, result} = parse(~w(--who joe), [options: [who: [type: :string]]])\n    iex> result.options.who\n    \"joe\"\n\n    iex> {:ok, result} = parse(~w(--who joe), [options: [who: []]])\n    iex> result.options.who\n    \"joe\"\n\n    iex> {:ok, result} = parse(~w(--port 4000), [options: [port: [type: :integer]]])\n    iex> result.options.port\n    4000\n\n    iex> {:ok, result} = parse(~w(-p 4000), [options: [port: [type: :integer, short: :p]]])\n    iex> result.options.port\n    4000\n\n    iex> parse(~w(--port nope), [options: [port: [type: :integer]]])\n    {:error, {:invalid, [{\"--port\", \"nope\"}]}}\n\n    iex> {:ok, result} = parse([], [options: [lang: [default: \"elixir\"]]])\n    iex> result.options.lang\n    \"elixir\"\n\n    iex> {:ok, result} = parse([], [options: [lang: []]])\n    iex> Map.has_key?(result.options, :lang)\n    false\n\n    iex> {:ok, result} = parse([], options: [])\n    iex> result.options.help\n    false\n\n    iex> {:ok, result} = parse(~w(--help), options: [])\n    iex> result.options.help\n    true\n\n#","ref":"AoC.CLI.html#parse/2-options-examples"},{"type":"function","title":"Defining arguments - AoC.CLI.parse/2","doc":"Arguments can be defined in the same way, providing a `Keyword` where the\nkeys are the argument names and the values are the parameters.\n\n#","ref":"AoC.CLI.html#parse/2-defining-arguments"},{"type":"function","title":"Defining arguments - AoC.CLI.parse/2","doc":"The following parameters are available:\n\n- `:required` - A boolean marking the argument as required. **Note that\n  arguments are required by default**. Keys for optional arguments that\n  are not provided by the command line will not be defined in the results.\n- `:cast` - Accepts a fun or a `{module, function, arguments}` tuple to\n  transform the argument value when parsing. The invoked function must\n  return a result tuple: `{:ok, _} | {:error, _}`.\n- `:doc` - Accepts a string that will be used when formatting the usage\n  block for the command. Note that this is not currently implemented for\n  arguments.\n\n#","ref":"AoC.CLI.html#parse/2-defining-arguments"},{"type":"function","title":"Arguments examples - AoC.CLI.parse/2","doc":"iex> {:ok, result} = parse(~w(joe), arguments: [who: []])\n    iex> result.arguments.who\n    \"joe\"\n\n    iex> parse([], arguments: [who: []])\n    {:error, {:missing_argument, :who}}\n\n    iex> {:ok, result} = parse([], arguments: [who: [required: false]])\n    iex> result.arguments\n    %{}\n\n    iex> cast = fn string -> Date.from_iso8601(string) end\n    iex> {:ok, result} = parse([\"2022-12-22\"], arguments: [date: [cast: cast]])\n    iex> result.arguments.date\n    ~D[2022-12-22]\n\n    iex> cast = {Date, :from_iso8601, []}\n    iex> {:ok, result} = parse([\"2022-12-22\"], arguments: [date: [cast: cast]])\n    iex> result.arguments.date\n    ~D[2022-12-22]\n\n    iex> cast = {Date, :from_iso8601, []}\n    iex> parse([\"not-a-date\"], arguments: [date: [cast: cast]])\n    {:error, {:argument_cast, :date, :invalid_format}}","ref":"AoC.CLI.html#parse/2-arguments-examples"},{"type":"function","title":"AoC.CLI.parse_or_halt!/2","doc":"Attempts to parse the command line arguments `argv` with the defined\ncommand.\n\nCommand options and arguments are documented in the `parse/2` function of\nthis module.\n\nIn `parse_or_halt!/2`, the successful return value will not be wrapped in\nan `:ok` tuple, but directly a map with the `:options` and `:arguments`\nkeys.\n\nIn case of a parse error, this function will output the usage block\nfollowed by a formatted error message, and halt the Erlang runtime.","ref":"AoC.CLI.html#parse_or_halt!/2"},{"type":"function","title":"AoC.CLI.part_command/2","doc":"","ref":"AoC.CLI.html#part_command/2"},{"type":"function","title":"AoC.CLI.put_shell/1","doc":"Defines the current shell to send console messages to. Accepts either\n`AoC.CLI` or `AoC.CLI.ProcessShell`.\n\nThe shell is saved to `:persistent_term`, so shell should not be changed\nrepeatedly during runtime. This method of persistence is subject to change\nand should not be relied on.","ref":"AoC.CLI.html#put_shell/1"},{"type":"function","title":"AoC.CLI.shell/0","doc":"Returns the current shell used by AoC.CLI to send output.","ref":"AoC.CLI.html#shell/0"},{"type":"function","title":"AoC.CLI.success/1","doc":"Outputs `iodata` in the current shell, formatted with green color.","ref":"AoC.CLI.html#success/1"},{"type":"function","title":"AoC.CLI.validate_options!/1","doc":"","ref":"AoC.CLI.html#validate_options!/1"},{"type":"function","title":"AoC.CLI.warn/1","doc":"Outputs `iodata` to `stderr` in the current shell, formatted with yellow\ncolor.","ref":"AoC.CLI.html#warn/1"},{"type":"function","title":"AoC.CLI.write_defaults/1","doc":"","ref":"AoC.CLI.html#write_defaults/1"},{"type":"function","title":"AoC.CLI.writeln/1","doc":"Outputs `iodata` in the current shell.","ref":"AoC.CLI.html#writeln/1"},{"type":"function","title":"AoC.CLI.year_day_command/2","doc":"","ref":"AoC.CLI.html#year_day_command/2"},{"type":"module","title":"AoC.Grid","doc":"","ref":"AoC.Grid.html"},{"type":"function","title":"AoC.Grid.bfs_path/4","doc":"","ref":"AoC.Grid.html#bfs_path/4"},{"type":"function","title":"AoC.Grid.bounds/1","doc":"","ref":"AoC.Grid.html#bounds/1"},{"type":"function","title":"AoC.Grid.cardinal4/1","doc":"","ref":"AoC.Grid.html#cardinal4/1"},{"type":"function","title":"AoC.Grid.cardinal8/1","doc":"","ref":"AoC.Grid.html#cardinal8/1"},{"type":"function","title":"AoC.Grid.max_x/1","doc":"","ref":"AoC.Grid.html#max_x/1"},{"type":"function","title":"AoC.Grid.max_x/2","doc":"","ref":"AoC.Grid.html#max_x/2"},{"type":"function","title":"AoC.Grid.max_y/1","doc":"","ref":"AoC.Grid.html#max_y/1"},{"type":"function","title":"AoC.Grid.max_y/2","doc":"","ref":"AoC.Grid.html#max_y/2"},{"type":"function","title":"AoC.Grid.min_x/1","doc":"","ref":"AoC.Grid.html#min_x/1"},{"type":"function","title":"AoC.Grid.min_x/2","doc":"","ref":"AoC.Grid.html#min_x/2"},{"type":"function","title":"AoC.Grid.min_y/1","doc":"","ref":"AoC.Grid.html#min_y/1"},{"type":"function","title":"AoC.Grid.min_y/2","doc":"","ref":"AoC.Grid.html#min_y/2"},{"type":"function","title":"AoC.Grid.parse_stream/2","doc":"","ref":"AoC.Grid.html#parse_stream/2"},{"type":"function","title":"AoC.Grid.print_map/2","doc":"","ref":"AoC.Grid.html#print_map/2"},{"type":"function","title":"AoC.Grid.translate/2","doc":"","ref":"AoC.Grid.html#translate/2"},{"type":"module","title":"AoC.Input","doc":"","ref":"AoC.Input.html"},{"type":"function","title":"AoC.Input.apply_stream_opt/3","doc":"","ref":"AoC.Input.html#apply_stream_opt/3"},{"type":"function","title":"AoC.Input.as_file/1","doc":"","ref":"AoC.Input.html#as_file/1"},{"type":"function","title":"AoC.Input.ensure_local/3","doc":"","ref":"AoC.Input.html#ensure_local/3"},{"type":"function","title":"AoC.Input.input_path/3","doc":"","ref":"AoC.Input.html#input_path/3"},{"type":"function","title":"AoC.Input.list_of_integers/1","doc":"","ref":"AoC.Input.html#list_of_integers/1"},{"type":"function","title":"AoC.Input.read!/1","doc":"","ref":"AoC.Input.html#read!/1"},{"type":"function","title":"AoC.Input.resolve/3","doc":"","ref":"AoC.Input.html#resolve/3"},{"type":"function","title":"AoC.Input.stream!/2","doc":"","ref":"AoC.Input.html#stream!/2"},{"type":"function","title":"AoC.Input.stream_file_lines/2","doc":"","ref":"AoC.Input.html#stream_file_lines/2"},{"type":"function","title":"AoC.Input.stream_to_integers/1","doc":"","ref":"AoC.Input.html#stream_to_integers/1"},{"type":"function","title":"AoC.Input.with_index_first/2","doc":"","ref":"AoC.Input.html#with_index_first/2"},{"type":"module","title":"AoC.Input.FakeFile","doc":"","ref":"AoC.Input.FakeFile.html"},{"type":"module","title":"AoC.Mod","doc":"","ref":"AoC.Mod.html"},{"type":"function","title":"AoC.Mod.module_name/2","doc":"","ref":"AoC.Mod.html#module_name/2"},{"type":"function","title":"AoC.Mod.test_module_name/2","doc":"","ref":"AoC.Mod.html#test_module_name/2"},{"type":"task","title":"mix aoc.create","doc":"","ref":"Mix.Tasks.Aoc.Create.html"},{"type":"function","title":"Mix.Tasks.Aoc.Create.print_path/2","doc":"","ref":"Mix.Tasks.Aoc.Create.html#print_path/2"},{"type":"function","title":"Mix.Tasks.Aoc.Create.run/1","doc":"","ref":"Mix.Tasks.Aoc.Create.html#run/1"},{"type":"task","title":"mix aoc.fetch","doc":"","ref":"Mix.Tasks.Aoc.Fetch.html"},{"type":"function","title":"Mix.Tasks.Aoc.Fetch.run/1","doc":"","ref":"Mix.Tasks.Aoc.Fetch.html#run/1"},{"type":"task","title":"mix aoc.open","doc":"","ref":"Mix.Tasks.Aoc.Open.html"},{"type":"function","title":"Mix.Tasks.Aoc.Open.run/1","doc":"","ref":"Mix.Tasks.Aoc.Open.html#run/1"},{"type":"task","title":"mix aoc.run","doc":"","ref":"Mix.Tasks.Aoc.Run.html"},{"type":"function","title":"Mix.Tasks.Aoc.Run.run/1","doc":"","ref":"Mix.Tasks.Aoc.Run.html#run/1"},{"type":"task","title":"mix aoc.set","doc":"","ref":"Mix.Tasks.Aoc.Set.html"},{"type":"function","title":"Mix.Tasks.Aoc.Set.run/1","doc":"","ref":"Mix.Tasks.Aoc.Set.html#run/1"},{"type":"task","title":"mix aoc.test","doc":"","ref":"Mix.Tasks.Aoc.Test.html"},{"type":"function","title":"Mix.Tasks.Aoc.Test.run/1","doc":"","ref":"Mix.Tasks.Aoc.Test.html#run/1"},{"type":"task","title":"mix aoc.url","doc":"","ref":"Mix.Tasks.Aoc.Url.html"},{"type":"function","title":"Mix.Tasks.Aoc.Url.run/1","doc":"","ref":"Mix.Tasks.Aoc.Url.html#run/1"},{"type":"extras","title":"License","doc":"MIT License\n\nCopyright (c) 2023 Ludovic Demblans\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"Overview","doc":"# Advent Of Code\n\nThis is a small framework to help with [Advent of\nCode](https://adventofcode.com/) by managing inputs, tests and boilerplate code\nwhile you focus on problem solving in a TDD fashion.","ref":"readme.html"},{"type":"extras","title":"Installation - Overview","doc":"#","ref":"readme.html#installation"},{"type":"extras","title":"Install the library - Overview","doc":"This framework is distributed as a library as it consists mostly of mix tasks.\nYou may add the dependency to your project, or add it to a new project created\nwith `mix new my_app`.\n\n```elixir\ndefp deps do\n  [\n    {:aoc, \"~> 0.10\"},\n  ]\nend\n```\n\n#","ref":"readme.html#install-the-library"},{"type":"extras","title":"Configuration - Overview","doc":"If it does not exist, create a configuration file in your application:\n\n```\nmkdir -p config\ntouch config/config.exs\n```\n\nThen add the following configuration:\n\n```elixir\nimport Config\n\n# The prefix is used when creating solutions and test modules with\n# `mix aoc.create`.\nconfig :aoc, prefix: MyApp\n```\n\n\n#","ref":"readme.html#configuration"},{"type":"extras","title":"Install your cookie - Overview","doc":"Retrieve your cookie from the AoC website (with you browser developer tools) and write the session\nID in `$HOME/.adventofcode.session`. It should be a long hex number like\n`53616c7465645f5f1d5792d97e3370392425dea84ca4653bd9a083f164ecd92278bef5b6bd50...`","ref":"readme.html#install-your-cookie"},{"type":"extras","title":"Use the commands - Overview","doc":"The following commands use the default year and day based on current date. It is\npossible to override the defaults with the `mix aoc.set` command, or provide the\n`--year` and `--day` options.\n\n* `mix aoc.create` – Create the solution file, the test file and the input file\n  for the current day. The input is downloaded from the AoC website and requires\n  the session cookie. But you can create any of those files manually and the\n  command will not overwrite them.\n* `mix aoc.fetch` – Download the input. This will not overwrite an existing\n  file. Inputs are stored in the `priv` directory.\n* `mix aoc.open` – Open the problem page on AoC website.\n* `mix aoc.url` – Prints the URL of the problem. Note that due to Elixir\n  compilation prints you may need to grep for the URL. For instance `xdg-open\n  $(mix aoc.url | grep 'https')`.\n* `mix aoc.test` – Run the tests. This relies on the `mix test` command and will\n  call it with the default test filename that would be generated byt `mix\n  aoc.create`. Supports the `--trace`, `--stale` and `--max-failures` options.\n* `mix aoc.run` – Run the solution. There are more options available\n  * `-p, --part` to run only one part\n  * `-b, --benchmark` to run the solution multiple times and print statistics\n    thanks to [Benchee](https://hex.pm/packages/benchee).","ref":"readme.html#use-the-commands"},{"type":"extras","title":"Defaults management commands - Overview","doc":"The `mix aoc.set` command allows to set the default year and day. Those values\nare used by default when other commands are not called with `--year` or `--day`\noptions.\n\nThis is useful when working on a problem from a previous year, or when you\nfinish the last days after December 25th, so your CLI history or bash scripts\ncan just call `mix aoc.test` or `mix aoc.run` without options.\n\n* `mix aoc.set --year 2022` – Set the default year to 2022\n* `mix aoc.set --day 12` – Set the default day\n* `mix aoc.set --year 2022 --day 12` – Set both defaults\n* `mix aoc.set` – Delete the default values","ref":"readme.html#defaults-management-commands"},{"type":"extras","title":"Writing solutions - Overview","doc":"The `mix aoc.create` command will generate modules with the boilerplate code to\nbe called by `mix aoc.run` and the generated tests.\n\n```elixir\ndefmodule MyApp.Y23.Day1 do\n  alias AoC.Input, warn: false\n\n  def read_file(file, _part) do\n    # Return each line\n    Input.stream!(file, trim: true)\n    # Or return the whole file\n    # Input.read!(file)\n  end\n\n  def parse_input(input, _part) do\n    input\n  end\n\n  def part_one(problem) do\n    problem\n  end\n\n  def part_two(problem) do\n    problem\n  end\nend\n```\n\nTo call your code manually, you may use the following code:\n\n```elixir\nsolution_for_p1 =\n  \"path/to/input/file\"\n  |> MyApp.Y23.Day1.read_file(:part_one)\n  |> MyApp.Y23.Day1.parse_input(:part_one)\n  |> MyApp.Y23.Day1.part_one()\n```\n\nThe generated tests will also call those functions one by one, so you can debug\nand assert each part separately.\n\nThe different callbacks are:\n\n* `read_file/2` and `parse_input/2` – The first one accepts an input file path,\n  or a `AoC.Input.FakeFile` struct from the tests. Call `Input.read!` or\n  `Input.stream!` to return the whole contents or a stream of lines.\n\n  The return value will be passed to `parse_input/2`. This allows to separate\n  the parsing logic from the raw file manipulation. Most logic is generally\n  contained in one of those two functions, and the other one is a oneliner.\n\n  Note that the second argument to each callback, `:part_one` or `:part_two` can\n  help to apply different logic for each problem part.\n\n* `part_one/1` and `part_two/1` – The first argument is the result of\n  `parse_input/2`. The return should be the solution to the problem that will be\n  printed by `mix aoc.run`.\n\n  The return value is also checked in the generated tests.\n\n  Some problems may require to print a drawing to the console, or produce other\n  side effects, so you may return a dummy value those callbacks.","ref":"readme.html#writing-solutions"}],"content_type":"text/markdown"}